###############################################################################
# BoardIndex.pl                                                               #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 1 Gold - SP 1.1                                        #
# Released:       December 2001; Updated March 22, 2002                       #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2002 Xnull (www.xnull.com) - All Rights Reserved.        #
# Software by: The YaBB Development Team                                      #
#              with assistance from the YaBB community.                       #
###############################################################################

$boardindexplver = "1 Gold - SP 1.1";

sub BoardIndex {
	# Open the file with all categories
	fopen(FILE, "$vardir/cat.txt");
	@categories = <FILE>;
	fclose(FILE);
	my($memcount, $latestmember) = &MembershipGet;
	$totalm = 0;
	$totalt = 0;
	foreach $curcat (@categories) {
		chomp $curcat;
		fopen(FILE, "$boardsdir/$curcat.cat");
		$catname{$curcat} = <FILE>;
		chomp $catname{$curcat};
		$cataccess{$curcat} = <FILE>;
		chomp $cataccess{$curcat};
		@{$catboards{$curcat}} = <FILE>;
		fclose(FILE);
		@membergroups = split( /,/, $cataccess{$curcat} );
		$openmemgr{$curcat} = 0;
        	fopen(accset, "$memberdir/$username.kri"); 
		@youraccess = <accset>; 
     	        fclose(accset); 
		foreach $value (@youraccess) { chomp $value; }
     	        foreach $tmpa (@membergroups) { 
                  if($tmpa eq $settings[7] || $tmpa eq $youraccess[0] || $tmpa eq $youraccess[1] || $tmpa eq $youraccess[2] || $tmpa eq $youraccess[3] || $tmpa eq $youraccess[4]) { $openmemgr{$curcat} = 1; last; } } 
		if(!$cataccess{$curcat} || $settings[7] eq 'Administrator') { $openmemgr{$curcat} = 1; }
		unless($openmemgr{$curcat}) { next; }
		foreach $curboard (@{$catboards{$curcat}}) {
			chomp $curboard;
			( $threadcount, $messagecount, $lastposttime, $lastposter ) = &BoardCountGet($curboard);


			$lastposttime{$curboard} = $lastposttime eq 'N/A' || ! $lastposttime ? $txt{'470'} : &timeformat($lastposttime);
			$lastpostrealtime{$curboard} = $lastposttime eq 'N/A' || ! $lastposttime ? '' : $lastposttime;
			if( $lastposter =~ m~\AGuest-(.*)~ ) {
				$lastposter = $1;
				$lastposterguest{$curboard} = 1;
			}
			$lastposter{$curboard} = $lastposter eq 'N/A' || ! $lastposter ? $txt{'470'} : $lastposter;
			$messagecount{$curboard} = $messagecount || 0;
			$threadcount{$curboard} = $threadcount || 0;
			$totalm += $messagecount;
			$totalt += $threadcount;
		}
	}

	$curforumurl = $curposlinks ? qq~<a href="$scripturl" class="nav">$mbname</a>~ : $mbname;
	$yymain .= qq~
<P align="left"><font size="2" class="nav"><IMG SRC="$imagesdir/open.gif" BORDER="0" alt=""> <b>$curforumurl</b></font>~;
	if($shownewsfader == 1) {
		if(!$fadedelay) { $fadedelay = 5000; }
		$yymain .= qq~
<table border=0 width="100%" cellspacing="0" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor">
  <tr>
    <td>
    <table cellpadding="4" cellspacing="1" border="0" width="100%">
      <tr>
        <td bgcolor="$color{'titlebg'}" class="titlebg" align="center"><font class="text1" color="$color{'titletext'}" size="2"><b>$txt{'102'}</b></font></td>
      </tr><tr>
        <td bgcolor="$color{'windowbg2'}" valign="middle" align="center" height="60">
<script language="JavaScript1.2" type="text/javascript">
<!--
var delay = $fadertime
var bcolor = "$color{'windowbg2'}"
var tcolor = "$color{'fadertext'}"
var fcontent = new Array()
begintag = '<font size="2"><B>'
~;
fopen(FILE, "$vardir/news.txt");
@newsmessages = <FILE>;
fclose(FILE);
for($i=0; $i < @newsmessages; $i++) {
	$newsmessages[$i] =~ s/\n|\r//g;
	if($i != 0){ $yymain .= qq~\n~; }
	$message = $newsmessages[$i];
	if($enable_ubbc) { if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &DoUBBC; }
	$message =~ s/\"/\\\"/g;
	$yymain .= qq~fcontent[$i] = "$message"~;
}
$yymain .= qq~

closetag = '</b></font>'
// -->
</script>
<script language="JavaScript1.2" type="text/javascript" src="$faderpath"></script>
<script language="JavaScript1.2" type="text/javascript">
<!--
if (navigator.appVersion.substring(0,1) < 5 && navigator.appName == "Netscape") {
   var fwidth = screen.availWidth / 2;
   var bwidth = screen.availWidth / 4;
   document.write('<ilayer id="fscrollerns" width='+fwidth+' height=35 left='+bwidth+' top=0><layer id="fscrollerns_sub" width='+fwidth+' height=35 left=0 top=0></layer></ilayer>');
   window.onload = fade;
}
else if (navigator.userAgent.search(/Opera/) != -1 || (navigator.platform != "Win32" && navigator.userAgent.indexOf('Gecko') == -1)) {
   document.open();
   document.write('<div id="fscroller" style="width:90% height:15px; padding:2px">');
   for(i=0; i < fcontent.length; ++i) {
      document.write(begintag+fcontent[i]+closetag+'<br>');
   }
   document.write('</div>');
   document.close();
   window.onload = fade;
}
else {
   document.write('<div id="fscroller" style="width:90% height:15px; padding:2px"></div>');
   window.onload = fade;
}
// -->
</script>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
~;
	}
	$yymain .= qq~
<table border=0 width="100%" cellspacing="0" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor">
  <tr>
    <td>
    <table cellpadding="4" cellspacing="1" border="0" width="100%">
      <tr>
        ~;

########### Board Folding Mod ##########

    # expand/collapse all buttons

    if ( $username ne 'Guest' ){

       $yymain .= qq~

       <td class="titlebg" bgcolor="$color{'titlebg'}" colspan="2">

          <table>

          <tr>

               <td>

                  <a href=$cgi&action=collapse_all&status=1><img src="$imagesdir/fold_up.gif" alt="$foldtxt{'6'}" border="0"></a></td>

               </td>

               <td>

                 <font class="text1" color="$color{'titletext'}" size="2"><b>$txt{'20'}</b></font></td>

                </td>

               <td>

                  <a href=$cgi&action=collapse_all&status=0><img src="$imagesdir/fold_out.gif" alt="$foldtxt{'5'}" border="0"></a></td>

               </td>

          </tr>

          </table>

       </td>~;

    }

    else{

       $yymain .= qq~<td class="titlebg" bgcolor="$color{'titlebg'}" colspan="2"><font class="text1" color="$color{'titletext'}" size="2"><b>$txt{'20'}</b></font></td>~;

    }

########### Board Folding Mod ##########

$yymain .= qq~
        <td class="titlebg" bgcolor="$color{'titlebg'}" width="1%" align="center"><font class="text1" color="$color{'titletext'}" size="2"><b>$txt{'330'}</b></font></td>
        <td class="titlebg" bgcolor="$color{'titlebg'}" width="1%" align="center"><font class="text1" color="$color{'titletext'}" size="2"><b>$txt{'21'}</b></font></td>
        <td class="titlebg" bgcolor="$color{'titlebg'}" width="24%" align="center"><font class="text1" color="$color{'titletext'}" size="2"><b>$txt{'22'}</b></font></td>
      </tr>~;

########### Board Folding Mod ##########

   # init catstatus counter

   $catcount=0;

   if ( $username ne 'Guest' ){

      # load the .cat file for this user, put into array

      fopen(FILE, "$memberdir/$username.cat");

      @catstatus = <FILE>;

      fclose(FILE);



      # remove trailing newline chars

      for( $catnum = 0; $catnum < @catstatus; $catnum++ ) {

         chomp $catstatus[$catnum];

      }



      # .cat file for this user not found, or number of categories changed?

      if ( @catstatus ne @categories ){

         # write new .cat file for user

         fopen( FILE, ">$memberdir/$username.cat", 1);

         for( $catnum = 0; $catnum < @categories; $catnum++ ) {

            print FILE "1\n";

         }

         fclose(FILE);

      }

   }

########### Board Folding Mod ##########


	foreach $curcat (@categories) {
		unless( $openmemgr{$curcat} ) { next; }
		####
		if ($catpic{$curcat} =~ /\//i) {$catpic{$curcat} = qq~ <img src="$catpic{$curcat}" alt="" border="0" align="absmiddle"> ~;}
		elsif ($catpic{$curcat}) {$catpic{$curcat} = qq~ <img src="$imagesdir/$catpic{$curcat}" alt="" border="0" align="absmiddle"> ~;}
		####
		$yymain .= qq~<tr>
              ~;

########### Board Folding Mod ##########

	if ( $username ne 'Guest' ) {

		$newcount = 0;

		if( $catstatus[$catcount]){

			$foldpic = "fold_out.gif";

			$foldtxt = $foldtxt{'2'};

		}else{

			foreach $curboard (@{$catboards{$curcat}}) {

				chomp $curboard;

				$dlp = &getlog($curboard);

				if( $max_log_days_old && $lastposttime{$curboard} ne $txt{'470'} && $username ne 'Guest' && $dlp < stringtotime( $lastpostrealtime{$curboard} ) ) {

					$newcount++;

				}

			}

			if($newcount>0){

				$foldpic = "fold_up_new_mail.gif";

				$foldtxt = $foldtxt{'1'};

			}

			if($newcount==0){

				$foldpic = "fold_up.gif";

				$foldtxt = $foldtxt{'1'};

			}

		}

         $yymain .= qq~

         <td colspan="5" class="catbg" bgcolor="$color{'catbg'}" height="18"><a name="$curcat"><a href=$cgi&action=collapse_cat&cat=$catcount><img src="$imagesdir/$foldpic" alt="$foldtxt" border="0"> $catpic{$curcat}<font color="#ffffff" size="2"><b>$catname{$curcat}</b></font></a></td>~;
      }

      else{

         $yymain .= qq~

         <td colspan="5" class="catbg" bgcolor="$color{'catbg'}" height="18"><a name="$curcat"> $catpic{$curcat}<font size="2"><b>$catname{$curcat}</b></font></a></td>~;

      }

########### Board Folding Mod ##########

      $yymain .= qq~


      </tr>~;
########### Board Folding Mod ##########

   # if category is open, display boards (or if this user is a guest)

   if( $catstatus[$catcount] || $username eq 'Guest' ){

########### Board Folding Mod ##########


		foreach $curboard (@{$catboards{$curcat}}) {
			chomp $curboard;
			my $access = &AccessCheck($curboard, '');
			if ($settings[7] ne "Administrator" && $access ne "granted" && $showprivboards{$curboard} ne "1") {next;}
			fopen(FILE, "$boardsdir/$curboard.dat");
			$curboardname = <FILE>;
			chomp $curboardname;
			$curboarddescr = <FILE>;
			chomp $curboarddescr;
			$curboardmods = <FILE>;
			chomp $curboardmods;
			fclose(FILE);
			%moderators = ();
			foreach $curuser (split(/\|/, $curboardmods)) {
				&LoadUser($curuser);
				$moderators{$curuser} = $userprofile{$curuser}->[1];

			}
			$showmods = '';
			if(scalar keys %moderators == 1) { $showmods = qq~$txt{'298'}: ~; }
			elsif(scalar keys %moderators != 0) { $showmods = qq~$txt{'299'}: ~; }
			while($tmpa = each(%moderators)) {
				&FormatUserName($tmpa);
				$showmods .= qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$tmpa}">$moderators{$tmpa}</a>, ~;
			}
			$showmods =~ s/, \Z//;
			if($showmods eq "") { $showmods = qq~$txt{'298'}: $txt{'470'}~; }
			$dlp = &getlog($curboard);
			if( $max_log_days_old && $lastposttime{$curboard} ne $txt{'470'} && $username ne 'Guest' && $dlp < stringtotime( $lastpostrealtime{$curboard} ) ) {
				$new = qq~<img src="$imagesdir/on.gif" alt="$txt{'333'}" border="0">~;
			}
			else { $new = qq~<img src="$imagesdir/off.gif" alt="$txt{'334'}" border="0">~; }
			$lastposter = $lastposter{$curboard};
			unless( $lastposterguest{$curboard} || $lastposter{$curboard} eq $txt{'470'} ) {
				$lastposterid = $lastposter;
				&LoadUser($lastposterid);
				if($userprofile{$lastposter}->[1]) { $lastposter = qq~<a href="$scripturl?action=viewprofile;username=$lastposterid">$userprofile{$lastposter}->[1]</a>~; }
			}
			$lastposter ||= $txt{'470'};
			$lastposttime ||= $txt{'470'};
			####
			$boardpic = "";
			if (-e "$boardsdir/$curboard.mbo" ) { require "$boardsdir/$curboard.mbo"; }
			if ($boardpic{$curboard} =~ /\//i) {$boardpic{$curboard} = qq~ <img src="$boardpic{$curboard}" alt="" border="0" align="absmiddle"> ~;}
			elsif ($boardpic{$curboard}) {$boardpic{$curboard} = qq~ <img src="$imagesdir/$boardpic{$curboard}" alt="" border="0" align="absmiddle"> ~;}

			my $cookiename = "$cookiepassword$curboard";
			my $crypass = crypt($boardpw{$curboard},$pwseed);
			my $boardpwpic = "";
			if ($settings[7] ne "Administrator" && $boardpw{$curboard} && $yyCookies{$cookiename} ne $crypass) {$boardpwpic = qq~<img border="0" alt="" align="absmiddle" src="$imagesdir/locking.gif">~;}
			elsif ($boardpw{$curboard}) {$boardpwpic = qq~<img border="0" align="absmiddle" alt="" src="$imagesdir/lockopen.gif">~;}
			####
			$yymain .= qq~<tr>
        <td class="windowbg" bgcolor="$color{'windowbg'}" width="8%" align="center" valign="top">$new</td>
        <td class="windowbg2" bgcolor="$color{'windowbg2'}" align="left" width="66%">
        <a name="$curboard"></a>
        <font size=2><a href="$scripturl?board=$curboard">$boardpic{$curboard}<B>$curboardname $boardpwpic</B></a></font>
        <br><font size="1">$curboarddescr<BR>
        <i>$showmods</i></font></td>
        <td class="windowbg" bgcolor="$color{'windowbg'}" valign="middle" align="center" width="1%"><font size="2">$threadcount{$curboard}</font></td>
        <td class="windowbg" bgcolor="$color{'windowbg'}" valign="middle" align="center" width="1%"><font size="2">$messagecount{$curboard}</font></td>
        <td class="windowbg2" bgcolor="$color{'windowbg2'}" valign="middle" width="24%"><font size="1">$lastposttime{$curboard}<BR>$txt{'525'} $lastposter</font></td>
      </tr>~;
		}
########### Board Folding Mod ##########

     #endif

     }

     ++$catcount;

########### Board Folding Mod ##########
	}
	my $checkadded = 0;
	$guests = 0;
	$users = '';
	$numusers = 0;
	fopen(FILE, "$vardir/log.txt");
	@entries = <FILE>;
	fclose(FILE);
	foreach $curentry (@entries) {
		chomp $curentry;
		($name, $value) = split(/\|/, $curentry);
		if($name) {
			if(!$yyUDLoaded{$musername}) { &LoadUser($name); }
			if(exists $userprofile{$name}) {
				$numusers++;
				$users .= qq~ <a href="$scripturl?action=viewprofile;username=$useraccount{$name}">$userprofile{$name}->[1]</a><font size="1">,</font> \n~;
			}
			else { $guests++; }
		}
	}
	$users =~ s~<font size="1">,</font> \n\Z~~;
	if($username ne 'Guest') {
		$ims = @immessages;
### LIMITED IM MOD ###
	$yymain .= qq~
		<script language="javascript">
		function viewinstant() {
		window.open("$cgi;action=im")
		}
		</script>
		~;

		if ($minnum > $numibox && $numibox ne "" && $enable_imlimit == 1) {
		$yymain .= qq~
		<script language=\"javascript\">
		if(confirm('$imtxt{'11'} $minnum $imtxt{'12'} $txt{'316'}!\\n$numibox $imtxt{'18'}')) {
		viewinstant();
		}
		else cancel() 
		</script>~;
&Del_Max_IM; 
}

		if ($moutnum > $numobox && $numobox ne "" && $enable_imlimit == 1) {
		$yymain .= qq~
		<script language=\"javascript\">
		if(confirm('$imtxt{'11'} $moutnum $imtxt{'12'} $txt{'320'}!\\n$numobox $imtxt{'18'}')) {
		viewinstant();
		}
		else cancel() 
		</script>~;
&Del_Max_IMOUT; 
}
		$ims = qq~<BR>$txt{'796'} <a href="$scripturl?action=im"><B>$ims</B></a> $imtxt{'24'}: <a href="$scripturl?action=im"><B>$imnewcount</B></a>~;
### END LIMITED IM ###
		$yymain .= qq~<tr>
        <td class="catbg" bgcolor="$color{'catbg'}" colspan="6" align="center">
        <table cellpadding="0" border="0" cellspacing="0" width="100%">
          <tr>
            <td align="left"> <font size="1">
            <img src="$imagesdir/on.gif" border=0 alt="$txt{'333'}"> $txt{'333'}&nbsp;&nbsp;
            <img src="$imagesdir/off.gif" border=0 alt="$txt{'334'}"> $txt{'334'}</font></td>
            <td align="right"><font size=1>&nbsp;
~;
	if($showmarkread) { $yymain .= qq~<a href="$scripturl?action=markallasread">$img{'markallread'}</a>~; }
	$yymain .= qq~
            </font></td>
          </tr>
        </table>
        </td>
      </tr>~;
	}
	$yymain .= qq~
    </table>
    </td>
  </tr>
</table>
<BR><BR>
<table border=0 width="100%" cellspacing="0" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor">
  <tr>
    <td>
    <table cellpadding="4" cellspacing="1" border="0" width="100%">
      <tr>
        <td bgcolor="$color{'titlebg'}" class="titlebg" align="center" colspan="2">
        <font class="text1" color="$color{'titletext'}" size="2"><b>$txt{'685'}</b></font></td>
      </tr>~;
	$yymain .= qq~<tr>
        <td class="catbg" bgcolor="$color{'catbg'}" colspan="2"> <font size="2" class="catbg"><b>$txt{'200'}</b></font></td>
      </tr><tr>
        <td class="windowbg" bgcolor="$color{'windowbg'}" width="20" valign="middle" align="center"><img src="$imagesdir/info.gif" border="0" alt=""></td>
        <td class="windowbg2" bgcolor="$color{'windowbg2'}" valign="top" align="center"><font size="1">
        <table width="98%" cellpadding="3" align="center">
          <tr>
            <td valign="top" align="left" width="60%"><font size="1">
            $txt{'490'} <B>$totalt</B> &nbsp; - &nbsp; $txt{'489'} <B>$totalm</B>
	    ~;
	if($Show_RecentBar) {
		require "$sourcedir/Recent.pl";
		&LastPost;
	}
	$yymain .= qq~
	    </font></td>
	    <td valign="top" align="left" width="40%"><font size="1">
	    $txt{'488'} <a href="$scripturl?action=mlall"><B>$memcount</B></a>
	    ~;
	if ($showlatestmember) {
		&LoadUser($latestmember);
		$yymain .= qq~<BR>$txt{'201'}: <a href="$scripturl?action=viewprofile;username=$useraccount{$latestmember}"><b>$userprofile{$latestmember}->[1]</b></a>~;
	}
	$yymain .= qq~
	    $ims
	    </font></td>
	  </tr>
	</table>
	</font></td>
      </tr><tr>
        <td class="catbg" bgcolor="$color{'catbg'}" colspan="2"> <font size="2" class="catbg"><b>$txt{'158'}</b></font></td>
      </tr><tr>
        <td class="windowbg" bgcolor="$color{'windowbg'}" width="20" valign="middle" align="center"><img src="$imagesdir/online.gif" border="0" alt=""></td>
        <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size=1>
        <table width="98%" cellpadding="3" align="center">


          <tr>
            <td valign="top" align="left"><font size="1">
            $guests $txt{'141'}, $numusers $txt{'142'}<BR>$users
            </font></td>
          </tr>
        </table>
        </font></td>
      </tr>~;
if ($newcalopen == 1 || $settings[7] eq 'Administrator' || $settings[7] eq $newcalgroup ) {
	$yymain .=qq~
       <tr>
        <td class="catbg" bgcolor="$color{'catbg'}" colspan="2"> <font size="2" class="catbg"><b>$ecaltxt{'55'}</b></font></td>
      </tr><tr>
        <td class="windowbg" bgcolor="$color{'windowbg'}" width="20" valign="middle" align="center"><a href="$cgi;action=newcalendar"><img src="$imagesdir/newcal.gif" border="0" alt=""></a></td>
        <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size=1>
        <table width="98%" cellpadding="3" align="center">
          <tr>
            <td valign="top" align="left"><font size="1">~;
require "$sourcedir/Newcalendar.pl";
&IndexCal;
$yymain .=qq~  
            </font></td>
          </tr>
        </table>
        </font></td>
      </tr>~;
}
########chat insertion###########
require "$vardir/ChatSettings.txt";
if ($chatopen == 1 || $settings[7] eq 'Administrator' || $settings[7] eq $chatgroup ) {
open(OF,"$Variables/online.txt");
@ary = <OF>;
$count = "0";
foreach $line (@ary) {
	$count++;
}
$yymain .=qq~
      <tr>
        <td class="catbg" bgcolor="$color{'catbg'}" colspan="2"> <font size="2" class="catbg"><b>$chadmtxt{'7'}</b></font></td>
      </tr><tr>
        <td class="windowbg" bgcolor="$color{'windowbg'}" width="20" valign="middle" align="center"><img src="$imagesdir/online.gif" border="0" alt=""></td>
        <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size=1>
        <table width="98%" cellpadding="3" align="center">
          <tr>
            <td valign="top" align="left"><font size="1">
~;
$cguests = 0;
$cusers = '';
open(OF,"$vardir/online.txt") or dienice ("Can't open file: $!");
@ary = <OF>;
foreach $line (@ary) {
    chomp($line);
        ($of,$ip,$name,$level,$time,$non1,$non2) = split(/\/,$line);
        		if( $name ) {
			&LoadUser($name);
			if( exists $userprofile{$name} ) {
				$cusers .= qq~ <a href="$scripturl?action=viewprofile&username=$useraccount{$name}">$userprofile{$name}->[1]</a><font size=1>,</font><br>~;
			}
			else { ++$cguests; }
			}
close(OF);
}

$yymain .=qq~
$cusers
~;

if ($password eq ""){	
if ($enable_guestposting == 0){
	$yymain .=qq~<br><font size=2>$chadmtxt{'8'}</font>~;}
	else {
	$yymain .=qq~
	$chadmtxt{'9'}$cguests
	<br><a href=javascript\:OpenAdsDetail(\'$cgi&action=chatnow&job=login&username=$username')>$chadmtxt{'10'}</a>
~;
}
}

elsif ($password ne "") {
if ($enable_guestposting == 1){
$yymain .=qq~$chadmtxt{'9'}$cguests~;
}
$yymain .=qq~
<br><a href=javascript\:OpenAdsDetail(\'$cgi&action=chatnow&job=login&username=$username')>$chadmtxt{'10'}</a>
~;
}
$yymain .=qq~
            </font></td>
          </tr>
        </table>
        </font></td>
      </tr>~;
}
########chat ended############

	if($username eq 'Guest') {
		require "$sourcedir/LogInOut.pl";
		$sharedLogin_title="$txt{'34'} <small><a href=\"$cgi;action=reminder\">($txt{'315'})</small></a>";
		&sharedLogin;
	}

	$yymain .= qq~
    </table>
    </td>
  </tr>
</table>
~;
		if($imnewcount > 0 && $enable_mailpopup == 1) {
			if($imnewcount > 1) { $en = "s"; $en2 = "them"; } else { $en = ""; $en2 = "the message"; }
			open(FILE, "$memberdir/$username.imconfig");
			@imuserdata = <FILE>;
			close(FILE);
			$imuserdata[3] =~ s/\n//g;
			if($imuserdata[3] eq "on") {
			$yymain .= qq~
			<script language=\"JavaScript\">
			function rimpu() {
			window.open('$cgi;action=im\')
			}
			</script>
			<script language=\"JavaScript\">
			function cancel () { 
			}
			</script>
			<script language=\"JavaScript\">
			<!-- BEGIN
			if (confirm(\"$imtxt{'13'} $imnewcount $imtxt{'14'}$en$imtxt{'15'} $en2?\")) {
			rimpu();
			} 
			else cancel()
			// END --> 
			</script>
			~;
			}
		}
	$yytitle = "$txt{'18'}";
	&template;
	exit;
}
########### Board Folding Mod ##########

sub Collapse_Cat {

   if ( $username eq 'Guest' ){

      &fatal_error($foldtxt{'4'});

      exit;            

   }

      

   # Grab the index of the category to collapse/expand

   $catindex = $INFO{'cat'};



   # read the current users category file

   fopen(FILE, "$memberdir/$username.cat");

   @catstatus = <FILE>;

   fclose(FILE);

  

   # remove trailing newline chars

   for( $catnum = 0; $catnum < @catstatus; $catnum++ ) {

      chomp $catstatus[$catnum];

      # fix in case using older version

      	if ( $catstatus[$catnum] eq "true" ){ $catstatus[$catnum] = 1; }

      	if ( $catstatus[$catnum] eq "false" ){ $catstatus[$catnum] = 0; } 

   }      

  

   # does the file exist?

   if ( $catstatus[0] != 1 && $catstatus[0] != 0 ){

      &fatal_error($foldtxt{'3'});

      exit;

   }

      

   # toggle the status of the selected category

   if ( $catstatus[$catindex] eq 1 ){

      $catstatus[$catindex] = 0;

   }

   else{

      $catstatus[$catindex] = 1;

   }



   # rewrite category file for this user

   fopen( FILE, ">$memberdir/$username.cat", 1);

   for( $catnum = 0; $catnum < @catstatus; $catnum++ ) {      

      print FILE "$catstatus[$catnum]\n";   

   }

   fclose(FILE);



   &redirectinternal;

   exit;   

}



sub Collapse_All {

   $state = '0';

   

   $state = $INFO{'status'};

   

   if ( $username eq 'Guest' ){

      &fatal_error($foldtxt{'4'});

      exit;            

   }   

   

   # read the current users category file

   fopen(FILE, "$memberdir/$username.cat");

   @catstatus = <FILE>;

   fclose(FILE);

  

   # remove trailing newline chars

   for( $catnum = 0; $catnum < @catstatus; $catnum++ ) {

      chomp $catstatus[$catnum];

      # fix in case using older version

      if ( $catstatus[$catnum] eq "true" ){ $catstatus[$catnum] = 1; }

      if ( $catstatus[$catnum] eq "false" ){ $catstatus[$catnum] = 0; }      

   }     

  

   # does the file exist?

   if ( $catstatus[0] != 1 && $catstatus[0] != 0 ){

      &fatal_error($foldtxt{'3'});

      exit;

   }   

   

   # rewrite category file for this user

   fopen( FILE, ">$memberdir/$username.cat", 1);

   for( $catnum = 0; $catnum < @catstatus; $catnum++ ) {      

      print FILE "$state\n";   

   }

   fclose(FILE);   



   &redirectinternal;

   exit;  

}

########### Board Folding Mod ##########


sub MarkAllRead {
	fopen(FILE, "$vardir/cat.txt");
	my @categories = <FILE>;
	fclose(FILE);
	my( $curcat, $curcatname, $curcataccess, @catboards, @membergroups, $openmemgr, $curboard );
	foreach $curcat (@categories) {
		chomp $curcat;
		fopen(FILE, "$boardsdir/$curcat.cat");
		$curcatname = <FILE>;
		$curcataccess = <FILE>;
		chomp $curcatname;
		chomp $curcataccess;
		@catboards = <FILE>;
		fclose(FILE);
		@membergroups = split( /,/, $curcataccess );
		$openmemgr = 0;
		foreach (@membergroups) {
			if( $_ eq $settings[7]) { $openmemgr = 1; last; }
		}
		if(!$curcataccess || $settings[7] eq 'Administrator') { $openmemgr = 1; }
		unless( $openmemgr ) { next; }
		foreach $curboard (@catboards) {
			chomp $curboard;
			&modlog("$curboard--mark");
			&modlog($curboard);
		}
	}
	&dumplog;
	&BoardIndex;
}

1;